
#include <math.h>
#include <utility>
#include <map>
#include <ptv.h>
#include <DofT.h>
#include <ScalarFunction.h>

using namespace std; 



/* ------------- order 2 1 ---------------*/


  
void matrix_factory_div_3D_order2_1 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& idof, 
         DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    ivdof[20];
  double vdof0[3];
  vdof0[0]=x0;  vdof0[1]=y0;
  vdof0[2] = 0.0;
  ptv vpdof0(3,vdof0);
  ivdof[0] = idof.insert_dof(element,0,vpdof0);

  double vdof1[3];
  vdof1[0]=x0;  vdof1[1]=y0;
  vdof1[2] = 1.0;
  ptv vpdof1(3,vdof1);
  ivdof[1] = idof.insert_dof(element,1,vpdof1);

  double vdof2[3];
  vdof2[0]=G00/2.0+x0;  vdof2[1]=G10/2.0+y0;
  vdof2[2] = 0.0;
  ptv vpdof2(3,vdof2);
  ivdof[2] = idof.insert_dof(element,2,vpdof2);

  double vdof3[3];
  vdof3[0]=G00/2.0+x0;  vdof3[1]=G10/2.0+y0;
  vdof3[2] = 1.0;
  ptv vpdof3(3,vdof3);
  ivdof[3] = idof.insert_dof(element,3,vpdof3);

  double vdof4[3];
  vdof4[0]=G00+x0;  vdof4[1]=G10+y0;
  vdof4[2] = 0.0;
  ptv vpdof4(3,vdof4);
  ivdof[4] = idof.insert_dof(element,4,vpdof4);

  double vdof5[3];
  vdof5[0]=G00+x0;  vdof5[1]=G10+y0;
  vdof5[2] = 1.0;
  ptv vpdof5(3,vdof5);
  ivdof[5] = idof.insert_dof(element,5,vpdof5);

  double vdof6[3];
  vdof6[0]=G01/2.0+x0;  vdof6[1]=y0+G11/2.0;
  vdof6[2] = 0.0;
  ptv vpdof6(3,vdof6);
  ivdof[6] = idof.insert_dof(element,6,vpdof6);

  double vdof7[3];
  vdof7[0]=G01/2.0+x0;  vdof7[1]=y0+G11/2.0;
  vdof7[2] = 1.0;
  ptv vpdof7(3,vdof7);
  ivdof[7] = idof.insert_dof(element,7,vpdof7);

  double vdof8[3];
  vdof8[0]=G01/2.0+G00/2.0+x0;  vdof8[1]=G10/2.0+y0+G11/2.0;
  vdof8[2] = 0.0;
  ptv vpdof8(3,vdof8);
  ivdof[8] = idof.insert_dof(element,8,vpdof8);

  double vdof9[3];
  vdof9[0]=G01/2.0+G00/2.0+x0;  vdof9[1]=G10/2.0+y0+G11/2.0;
  vdof9[2] = 1.0;
  ptv vpdof9(3,vdof9);
  ivdof[9] = idof.insert_dof(element,9,vpdof9);

  double vdof10[3];
  vdof10[0]=G01+x0;  vdof10[1]=y0+G11;
  vdof10[2] = 0.0;
  ptv vpdof10(3,vdof10);
  ivdof[10] = idof.insert_dof(element,10,vpdof10);

  double vdof11[3];
  vdof11[0]=G01+x0;  vdof11[1]=y0+G11;
  vdof11[2] = 1.0;
  ptv vpdof11(3,vdof11);
  ivdof[11] = idof.insert_dof(element,11,vpdof11);

  double vdof12[3];
  vdof12[0]=x0;  vdof12[1]=y0;
  vdof12[2] = 0.0;
  ptv vpdof12(3,vdof12);
  ivdof[12] = idof.insert_dof(element,12,vpdof12);

  double vdof13[3];
  vdof13[0]=x0;  vdof13[1]=y0;
  vdof13[2] = 1.0;
  ptv vpdof13(3,vdof13);
  ivdof[13] = idof.insert_dof(element,13,vpdof13);

  double vdof14[3];
  vdof14[0]=G00/2.0+x0;  vdof14[1]=G10/2.0+y0;
  vdof14[2] = 0.0;
  ptv vpdof14(3,vdof14);
  ivdof[14] = idof.insert_dof(element,14,vpdof14);

  double vdof15[3];
  vdof15[0]=G00/2.0+x0;  vdof15[1]=G10/2.0+y0;
  vdof15[2] = 1.0;
  ptv vpdof15(3,vdof15);
  ivdof[15] = idof.insert_dof(element,15,vpdof15);

  double vdof16[3];
  vdof16[0]=G01/2.0+x0;  vdof16[1]=y0+G11/2.0;
  vdof16[2] = 0.0;
  ptv vpdof16(3,vdof16);
  ivdof[16] = idof.insert_dof(element,16,vpdof16);

  double vdof17[3];
  vdof17[0]=G01/2.0+x0;  vdof17[1]=y0+G11/2.0;
  vdof17[2] = 1.0;
  ptv vpdof17(3,vdof17);
  ivdof[17] = idof.insert_dof(element,17,vpdof17);

  double vdof18[3];
  vdof18[0]=x0;  vdof18[1]=y0;
  vdof18[2] = 0.0;
  ptv vpdof18(3,vdof18);
  ivdof[18] = idof.insert_dof(element,18,vpdof18);

  double vdof19[3];
  vdof19[0]=x0;  vdof19[1]=y0;
  vdof19[2] = 1.0;
  ptv vpdof19(3,vdof19);
  ivdof[19] = idof.insert_dof(element,19,vpdof19);

  int    ipdof[4];
  double dof0[2];
  dof0[0]=x0;  dof0[1]=y0;
  ptv pdof0(2,dof0);
  ipdof[0] = jdof.insert_dof(element,0,pdof0);

  double dof1[2];
  dof1[0]=G00+x0;  dof1[1]=G10+y0;
  ptv pdof1(2,dof1);
  ipdof[1] = jdof.insert_dof(element,1,pdof1);

  double dof2[2];
  dof2[0]=G01+x0;  dof2[1]=y0+G11;
  ptv pdof2(2,dof2);
  ipdof[2] = jdof.insert_dof(element,2,pdof2);

  double dof3[2];
  dof3[0]=x0;  dof3[1]=y0;
  ptv pdof3(2,dof3);
  ipdof[3] = jdof.insert_dof(element,3,pdof3);

 
  double Jinv00 = 1.0/(G00*G11-G10*G01)*G11;
  double Jinv01 = -1.0*1.0/(G00*G11-G10*G01)*G10;
  double Jinv10 = -1.0*1.0/(G00*G11-G10*G01)*G01;
  double Jinv11 = 1.0/(G00*G11-G10*G01)*G00;


  double A[4][20];
  A[0][0]=(-2.5000000000000001e-02*Jinv01-2.5000000000000001e-02*Jinv00)*D;
  A[0][1]=(-2.5000000000000001e-02*Jinv11-2.5000000000000001e-02*Jinv10)*D;
  A[0][2]=(-3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[0][3]=(-3.3333333333333333e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[0][4]=(-8.3333333333333332e-03*Jinv00)*D;
  A[0][5]=(-8.3333333333333332e-03*Jinv10)*D;
  A[0][6]=(3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[0][7]=(3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[0][8]=(3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[0][9]=(3.3333333333333333e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[0][10]=(-8.3333333333333332e-03*Jinv01)*D;
  A[0][11]=(-8.3333333333333332e-03*Jinv11)*D;
  A[0][12]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[0][13]=(-3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[0][14]=(3.3333333333333333e-02*Jinv00)*D;
  A[0][15]=(3.3333333333333333e-02*Jinv10)*D;
  A[0][16]=(3.3333333333333333e-02*Jinv01)*D;
  A[0][17]=(3.3333333333333333e-02*Jinv11)*D;
  A[0][18]=(0.0)*D;
  A[0][19]=(0.0)*D;
  A[1][0]=(8.3333333333333332e-03*Jinv01+8.3333333333333332e-03*Jinv00)*D;
  A[1][1]=(8.3333333333333332e-03*Jinv11+8.3333333333333332e-03*Jinv10)*D;
  A[1][2]=(-6.6666666666666666e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[1][3]=(-6.6666666666666666e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[1][4]=(2.5000000000000001e-02*Jinv00)*D;
  A[1][5]=(2.5000000000000001e-02*Jinv10)*D;
  A[1][6]=(-3.3333333333333333e-02*Jinv00)*D;
  A[1][7]=(-3.3333333333333333e-02*Jinv10)*D;
  A[1][8]=(6.6666666666666666e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[1][9]=(6.6666666666666666e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[1][10]=(-8.3333333333333332e-03*Jinv01)*D;
  A[1][11]=(-8.3333333333333332e-03*Jinv11)*D;
  A[1][12]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[1][13]=(-3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[1][14]=(3.3333333333333333e-02*Jinv00)*D;
  A[1][15]=(3.3333333333333333e-02*Jinv10)*D;
  A[1][16]=(3.3333333333333333e-02*Jinv01)*D;
  A[1][17]=(3.3333333333333333e-02*Jinv11)*D;
  A[1][18]=(0.0)*D;
  A[1][19]=(0.0)*D;
  A[2][0]=(8.3333333333333332e-03*Jinv01+8.3333333333333332e-03*Jinv00)*D;
  A[2][1]=(8.3333333333333332e-03*Jinv11+8.3333333333333332e-03*Jinv10)*D;
  A[2][2]=(-3.3333333333333333e-02*Jinv01)*D;
  A[2][3]=(-3.3333333333333333e-02*Jinv11)*D;
  A[2][4]=(-8.3333333333333332e-03*Jinv00)*D;
  A[2][5]=(-8.3333333333333332e-03*Jinv10)*D;
  A[2][6]=(-3.3333333333333333e-02*Jinv01-6.6666666666666666e-02*Jinv00)*D;
  A[2][7]=(-3.3333333333333333e-02*Jinv11-6.6666666666666666e-02*Jinv10)*D;
  A[2][8]=(3.3333333333333333e-02*Jinv01+6.6666666666666666e-02*Jinv00)*D;
  A[2][9]=(3.3333333333333333e-02*Jinv11+6.6666666666666666e-02*Jinv10)*D;
  A[2][10]=(2.5000000000000001e-02*Jinv01)*D;
  A[2][11]=(2.5000000000000001e-02*Jinv11)*D;
  A[2][12]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[2][13]=(-3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[2][14]=(3.3333333333333333e-02*Jinv00)*D;
  A[2][15]=(3.3333333333333333e-02*Jinv10)*D;
  A[2][16]=(3.3333333333333333e-02*Jinv01)*D;
  A[2][17]=(3.3333333333333333e-02*Jinv11)*D;
  A[2][18]=(0.0)*D;
  A[2][19]=(0.0)*D;
  A[3][0]=(8.3333333333333332e-03*Jinv01+8.3333333333333332e-03*Jinv00)*D;
  A[3][1]=(8.3333333333333332e-03*Jinv11+8.3333333333333332e-03*Jinv10)*D;
  A[3][2]=(-3.3333333333333333e-02*Jinv01)*D;
  A[3][3]=(-3.3333333333333333e-02*Jinv11)*D;
  A[3][4]=(-8.3333333333333332e-03*Jinv00)*D;
  A[3][5]=(-8.3333333333333332e-03*Jinv10)*D;
  A[3][6]=(-3.3333333333333333e-02*Jinv00)*D;
  A[3][7]=(-3.3333333333333333e-02*Jinv10)*D;
  A[3][8]=(3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[3][9]=(3.3333333333333333e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[3][10]=(-8.3333333333333332e-03*Jinv01)*D;
  A[3][11]=(-8.3333333333333332e-03*Jinv11)*D;
  A[3][12]=(-6.6666666666666666e-02*Jinv01-6.6666666666666666e-02*Jinv00)*D;
  A[3][13]=(-6.6666666666666666e-02*Jinv11-6.6666666666666666e-02*Jinv10)*D;
  A[3][14]=(6.6666666666666666e-02*Jinv00)*D;
  A[3][15]=(6.6666666666666666e-02*Jinv10)*D;
  A[3][16]=(6.6666666666666666e-02*Jinv01)*D;
  A[3][17]=(6.6666666666666666e-02*Jinv11)*D;
  A[3][18]=(0.0)*D;
  A[3][19]=(0.0)*D;
  int vnbf = 20;  int pnbf = 4;  

  pair<int,int> index; 
  for (int i=0; i< pnbf; i++) {
    index.first = ipdof[i]; 
    for (int j=0; j< vnbf; j++) {
      index.second = ivdof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}


/* ------------- order 3 1 ---------------*/


  
void matrix_factory_div_3D_order3_1 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& idof, 
         DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    ivdof[40];
  double vdof0[3];
  vdof0[0]=x0;  vdof0[1]=y0;
  vdof0[2] = 0.0;
  ptv vpdof0(3,vdof0);
  ivdof[0] = idof.insert_dof(element,0,vpdof0);

  double vdof1[3];
  vdof1[0]=x0;  vdof1[1]=y0;
  vdof1[2] = 1.0;
  ptv vpdof1(3,vdof1);
  ivdof[1] = idof.insert_dof(element,1,vpdof1);

  double vdof2[3];
  vdof2[0]=G00/3.0+x0;  vdof2[1]=G10/3.0+y0;
  vdof2[2] = 0.0;
  ptv vpdof2(3,vdof2);
  ivdof[2] = idof.insert_dof(element,2,vpdof2);

  double vdof3[3];
  vdof3[0]=G00/3.0+x0;  vdof3[1]=G10/3.0+y0;
  vdof3[2] = 1.0;
  ptv vpdof3(3,vdof3);
  ivdof[3] = idof.insert_dof(element,3,vpdof3);

  double vdof4[3];
  vdof4[0]=(2.0/3.0)*G00+x0;  vdof4[1]=(2.0/3.0)*G10+y0;
  vdof4[2] = 0.0;
  ptv vpdof4(3,vdof4);
  ivdof[4] = idof.insert_dof(element,4,vpdof4);

  double vdof5[3];
  vdof5[0]=(2.0/3.0)*G00+x0;  vdof5[1]=(2.0/3.0)*G10+y0;
  vdof5[2] = 1.0;
  ptv vpdof5(3,vdof5);
  ivdof[5] = idof.insert_dof(element,5,vpdof5);

  double vdof6[3];
  vdof6[0]=G00+x0;  vdof6[1]=G10+y0;
  vdof6[2] = 0.0;
  ptv vpdof6(3,vdof6);
  ivdof[6] = idof.insert_dof(element,6,vpdof6);

  double vdof7[3];
  vdof7[0]=G00+x0;  vdof7[1]=G10+y0;
  vdof7[2] = 1.0;
  ptv vpdof7(3,vdof7);
  ivdof[7] = idof.insert_dof(element,7,vpdof7);

  double vdof8[3];
  vdof8[0]=G01/3.0+x0;  vdof8[1]=y0+G11/3.0;
  vdof8[2] = 0.0;
  ptv vpdof8(3,vdof8);
  ivdof[8] = idof.insert_dof(element,8,vpdof8);

  double vdof9[3];
  vdof9[0]=G01/3.0+x0;  vdof9[1]=y0+G11/3.0;
  vdof9[2] = 1.0;
  ptv vpdof9(3,vdof9);
  ivdof[9] = idof.insert_dof(element,9,vpdof9);

  double vdof10[3];
  vdof10[0]=G01/3.0+G00/3.0+x0;  vdof10[1]=G10/3.0+y0+G11/3.0;
  vdof10[2] = 0.0;
  ptv vpdof10(3,vdof10);
  ivdof[10] = idof.insert_dof(element,10,vpdof10);

  double vdof11[3];
  vdof11[0]=G01/3.0+G00/3.0+x0;  vdof11[1]=G10/3.0+y0+G11/3.0;
  vdof11[2] = 1.0;
  ptv vpdof11(3,vdof11);
  ivdof[11] = idof.insert_dof(element,11,vpdof11);

  double vdof12[3];
  vdof12[0]=G01/3.0+(2.0/3.0)*G00+x0;  vdof12[1]=(2.0/3.0)*G10+y0+G11/3.0;
  vdof12[2] = 0.0;
  ptv vpdof12(3,vdof12);
  ivdof[12] = idof.insert_dof(element,12,vpdof12);

  double vdof13[3];
  vdof13[0]=G01/3.0+(2.0/3.0)*G00+x0;  vdof13[1]=(2.0/3.0)*G10+y0+G11/3.0;
  vdof13[2] = 1.0;
  ptv vpdof13(3,vdof13);
  ivdof[13] = idof.insert_dof(element,13,vpdof13);

  double vdof14[3];
  vdof14[0]=(2.0/3.0)*G01+x0;  vdof14[1]=y0+(2.0/3.0)*G11;
  vdof14[2] = 0.0;
  ptv vpdof14(3,vdof14);
  ivdof[14] = idof.insert_dof(element,14,vpdof14);

  double vdof15[3];
  vdof15[0]=(2.0/3.0)*G01+x0;  vdof15[1]=y0+(2.0/3.0)*G11;
  vdof15[2] = 1.0;
  ptv vpdof15(3,vdof15);
  ivdof[15] = idof.insert_dof(element,15,vpdof15);

  double vdof16[3];
  vdof16[0]=(2.0/3.0)*G01+G00/3.0+x0;  vdof16[1]=G10/3.0+y0+(2.0/3.0)*G11;
  vdof16[2] = 0.0;
  ptv vpdof16(3,vdof16);
  ivdof[16] = idof.insert_dof(element,16,vpdof16);

  double vdof17[3];
  vdof17[0]=(2.0/3.0)*G01+G00/3.0+x0;  vdof17[1]=G10/3.0+y0+(2.0/3.0)*G11;
  vdof17[2] = 1.0;
  ptv vpdof17(3,vdof17);
  ivdof[17] = idof.insert_dof(element,17,vpdof17);

  double vdof18[3];
  vdof18[0]=G01+x0;  vdof18[1]=y0+G11;
  vdof18[2] = 0.0;
  ptv vpdof18(3,vdof18);
  ivdof[18] = idof.insert_dof(element,18,vpdof18);

  double vdof19[3];
  vdof19[0]=G01+x0;  vdof19[1]=y0+G11;
  vdof19[2] = 1.0;
  ptv vpdof19(3,vdof19);
  ivdof[19] = idof.insert_dof(element,19,vpdof19);

  double vdof20[3];
  vdof20[0]=x0;  vdof20[1]=y0;
  vdof20[2] = 0.0;
  ptv vpdof20(3,vdof20);
  ivdof[20] = idof.insert_dof(element,20,vpdof20);

  double vdof21[3];
  vdof21[0]=x0;  vdof21[1]=y0;
  vdof21[2] = 1.0;
  ptv vpdof21(3,vdof21);
  ivdof[21] = idof.insert_dof(element,21,vpdof21);

  double vdof22[3];
  vdof22[0]=G00/3.0+x0;  vdof22[1]=G10/3.0+y0;
  vdof22[2] = 0.0;
  ptv vpdof22(3,vdof22);
  ivdof[22] = idof.insert_dof(element,22,vpdof22);

  double vdof23[3];
  vdof23[0]=G00/3.0+x0;  vdof23[1]=G10/3.0+y0;
  vdof23[2] = 1.0;
  ptv vpdof23(3,vdof23);
  ivdof[23] = idof.insert_dof(element,23,vpdof23);

  double vdof24[3];
  vdof24[0]=(2.0/3.0)*G00+x0;  vdof24[1]=(2.0/3.0)*G10+y0;
  vdof24[2] = 0.0;
  ptv vpdof24(3,vdof24);
  ivdof[24] = idof.insert_dof(element,24,vpdof24);

  double vdof25[3];
  vdof25[0]=(2.0/3.0)*G00+x0;  vdof25[1]=(2.0/3.0)*G10+y0;
  vdof25[2] = 1.0;
  ptv vpdof25(3,vdof25);
  ivdof[25] = idof.insert_dof(element,25,vpdof25);

  double vdof26[3];
  vdof26[0]=G01/3.0+x0;  vdof26[1]=y0+G11/3.0;
  vdof26[2] = 0.0;
  ptv vpdof26(3,vdof26);
  ivdof[26] = idof.insert_dof(element,26,vpdof26);

  double vdof27[3];
  vdof27[0]=G01/3.0+x0;  vdof27[1]=y0+G11/3.0;
  vdof27[2] = 1.0;
  ptv vpdof27(3,vdof27);
  ivdof[27] = idof.insert_dof(element,27,vpdof27);

  double vdof28[3];
  vdof28[0]=G01/3.0+G00/3.0+x0;  vdof28[1]=G10/3.0+y0+G11/3.0;
  vdof28[2] = 0.0;
  ptv vpdof28(3,vdof28);
  ivdof[28] = idof.insert_dof(element,28,vpdof28);

  double vdof29[3];
  vdof29[0]=G01/3.0+G00/3.0+x0;  vdof29[1]=G10/3.0+y0+G11/3.0;
  vdof29[2] = 1.0;
  ptv vpdof29(3,vdof29);
  ivdof[29] = idof.insert_dof(element,29,vpdof29);

  double vdof30[3];
  vdof30[0]=(2.0/3.0)*G01+x0;  vdof30[1]=y0+(2.0/3.0)*G11;
  vdof30[2] = 0.0;
  ptv vpdof30(3,vdof30);
  ivdof[30] = idof.insert_dof(element,30,vpdof30);

  double vdof31[3];
  vdof31[0]=(2.0/3.0)*G01+x0;  vdof31[1]=y0+(2.0/3.0)*G11;
  vdof31[2] = 1.0;
  ptv vpdof31(3,vdof31);
  ivdof[31] = idof.insert_dof(element,31,vpdof31);

  double vdof32[3];
  vdof32[0]=x0;  vdof32[1]=y0;
  vdof32[2] = 0.0;
  ptv vpdof32(3,vdof32);
  ivdof[32] = idof.insert_dof(element,32,vpdof32);

  double vdof33[3];
  vdof33[0]=x0;  vdof33[1]=y0;
  vdof33[2] = 1.0;
  ptv vpdof33(3,vdof33);
  ivdof[33] = idof.insert_dof(element,33,vpdof33);

  double vdof34[3];
  vdof34[0]=G00/3.0+x0;  vdof34[1]=G10/3.0+y0;
  vdof34[2] = 0.0;
  ptv vpdof34(3,vdof34);
  ivdof[34] = idof.insert_dof(element,34,vpdof34);

  double vdof35[3];
  vdof35[0]=G00/3.0+x0;  vdof35[1]=G10/3.0+y0;
  vdof35[2] = 1.0;
  ptv vpdof35(3,vdof35);
  ivdof[35] = idof.insert_dof(element,35,vpdof35);

  double vdof36[3];
  vdof36[0]=G01/3.0+x0;  vdof36[1]=y0+G11/3.0;
  vdof36[2] = 0.0;
  ptv vpdof36(3,vdof36);
  ivdof[36] = idof.insert_dof(element,36,vpdof36);

  double vdof37[3];
  vdof37[0]=G01/3.0+x0;  vdof37[1]=y0+G11/3.0;
  vdof37[2] = 1.0;
  ptv vpdof37(3,vdof37);
  ivdof[37] = idof.insert_dof(element,37,vpdof37);

  double vdof38[3];
  vdof38[0]=x0;  vdof38[1]=y0;
  vdof38[2] = 0.0;
  ptv vpdof38(3,vdof38);
  ivdof[38] = idof.insert_dof(element,38,vpdof38);

  double vdof39[3];
  vdof39[0]=x0;  vdof39[1]=y0;
  vdof39[2] = 1.0;
  ptv vpdof39(3,vdof39);
  ivdof[39] = idof.insert_dof(element,39,vpdof39);

  int    ipdof[4];
  double dof0[2];
  dof0[0]=x0;  dof0[1]=y0;
  ptv pdof0(2,dof0);
  ipdof[0] = jdof.insert_dof(element,0,pdof0);

  double dof1[2];
  dof1[0]=G00+x0;  dof1[1]=G10+y0;
  ptv pdof1(2,dof1);
  ipdof[1] = jdof.insert_dof(element,1,pdof1);

  double dof2[2];
  dof2[0]=G01+x0;  dof2[1]=y0+G11;
  ptv pdof2(2,dof2);
  ipdof[2] = jdof.insert_dof(element,2,pdof2);

  double dof3[2];
  dof3[0]=x0;  dof3[1]=y0;
  ptv pdof3(2,dof3);
  ipdof[3] = jdof.insert_dof(element,3,pdof3);

 
  double Jinv00 = 1.0/(G00*G11-G10*G01)*G11;
  double Jinv01 = -1.0*1.0/(G00*G11-G10*G01)*G10;
  double Jinv10 = -1.0*1.0/(G00*G11-G10*G01)*G01;
  double Jinv11 = 1.0/(G00*G11-G10*G01)*G00;


  double A[4][40];
  A[0][0]=(-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[0][1]=(-4.1666666666666666e-03*Jinv11-4.1666666666666666e-03*Jinv10)*D;
  A[0][2]=(-3.7499999999999999e-02*Jinv01)*D;
  A[0][3]=(-3.7499999999999999e-02*Jinv11)*D;
  A[0][4]=(0.0)*D;
  A[0][5]=(0.0)*D;
  A[0][6]=(4.1666666666666666e-03*Jinv00)*D;
  A[0][7]=(4.1666666666666666e-03*Jinv10)*D;
  A[0][8]=(-3.7499999999999999e-02*Jinv00)*D;
  A[0][9]=(-3.7499999999999999e-02*Jinv10)*D;
  A[0][10]=(3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[0][11]=(3.7499999999999999e-02*Jinv11+3.7499999999999999e-02*Jinv10)*D;
  A[0][12]=(0.0)*D;
  A[0][13]=(0.0)*D;
  A[0][14]=(0.0)*D;
  A[0][15]=(0.0)*D;
  A[0][16]=(0.0)*D;
  A[0][17]=(0.0)*D;
  A[0][18]=(4.1666666666666666e-03*Jinv01)*D;
  A[0][19]=(4.1666666666666666e-03*Jinv11)*D;
  A[0][20]=(-3.7499999999999999e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[0][21]=(-3.7499999999999999e-02*Jinv11-3.7499999999999999e-02*Jinv10)*D;
  A[0][22]=(-3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[0][23]=(-3.7499999999999999e-02*Jinv11+3.7499999999999999e-02*Jinv10)*D;
  A[0][24]=(0.0)*D;
  A[0][25]=(0.0)*D;
  A[0][26]=(3.7499999999999999e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[0][27]=(3.7499999999999999e-02*Jinv11-3.7499999999999999e-02*Jinv10)*D;
  A[0][28]=(3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[0][29]=(3.7499999999999999e-02*Jinv11+3.7499999999999999e-02*Jinv10)*D;
  A[0][30]=(0.0)*D;
  A[0][31]=(0.0)*D;
  A[0][32]=(0.0)*D;
  A[0][33]=(0.0)*D;
  A[0][34]=(0.0)*D;
  A[0][35]=(0.0)*D;
  A[0][36]=(0.0)*D;
  A[0][37]=(0.0)*D;
  A[0][38]=(0.0)*D;
  A[0][39]=(0.0)*D;
  A[1][0]=(-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[1][1]=(-4.1666666666666666e-03*Jinv11-4.1666666666666666e-03*Jinv10)*D;
  A[1][2]=(0.0)*D;
  A[1][3]=(0.0)*D;
  A[1][4]=(-3.7499999999999999e-02*Jinv01)*D;
  A[1][5]=(-3.7499999999999999e-02*Jinv11)*D;
  A[1][6]=(4.1666666666666666e-03*Jinv00)*D;
  A[1][7]=(4.1666666666666666e-03*Jinv10)*D;
  A[1][8]=(0.0)*D;
  A[1][9]=(0.0)*D;
  A[1][10]=(-3.7499999999999999e-02*Jinv00)*D;
  A[1][11]=(-3.7499999999999999e-02*Jinv10)*D;
  A[1][12]=(3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[1][13]=(3.7499999999999999e-02*Jinv11+3.7499999999999999e-02*Jinv10)*D;
  A[1][14]=(0.0)*D;
  A[1][15]=(0.0)*D;
  A[1][16]=(0.0)*D;
  A[1][17]=(0.0)*D;
  A[1][18]=(4.1666666666666666e-03*Jinv01)*D;
  A[1][19]=(4.1666666666666666e-03*Jinv11)*D;
  A[1][20]=(0.0)*D;
  A[1][21]=(0.0)*D;
  A[1][22]=(-7.4999999999999997e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[1][23]=(-7.4999999999999997e-02*Jinv11-3.7499999999999999e-02*Jinv10)*D;
  A[1][24]=(3.7499999999999999e-02*Jinv00)*D;
  A[1][25]=(3.7499999999999999e-02*Jinv10)*D;
  A[1][26]=(-3.7499999999999999e-02*Jinv00)*D;
  A[1][27]=(-3.7499999999999999e-02*Jinv10)*D;
  A[1][28]=(7.4999999999999997e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[1][29]=(7.4999999999999997e-02*Jinv11+3.7499999999999999e-02*Jinv10)*D;
  A[1][30]=(0.0)*D;
  A[1][31]=(0.0)*D;
  A[1][32]=(0.0)*D;
  A[1][33]=(0.0)*D;
  A[1][34]=(0.0)*D;
  A[1][35]=(0.0)*D;
  A[1][36]=(0.0)*D;
  A[1][37]=(0.0)*D;
  A[1][38]=(0.0)*D;
  A[1][39]=(0.0)*D;
  A[2][0]=(-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[2][1]=(-4.1666666666666666e-03*Jinv11-4.1666666666666666e-03*Jinv10)*D;
  A[2][2]=(0.0)*D;
  A[2][3]=(0.0)*D;
  A[2][4]=(0.0)*D;
  A[2][5]=(0.0)*D;
  A[2][6]=(4.1666666666666666e-03*Jinv00)*D;
  A[2][7]=(4.1666666666666666e-03*Jinv10)*D;
  A[2][8]=(0.0)*D;
  A[2][9]=(0.0)*D;
  A[2][10]=(-3.7499999999999999e-02*Jinv01)*D;
  A[2][11]=(-3.7499999999999999e-02*Jinv11)*D;
  A[2][12]=(0.0)*D;
  A[2][13]=(0.0)*D;
  A[2][14]=(-3.7499999999999999e-02*Jinv00)*D;
  A[2][15]=(-3.7499999999999999e-02*Jinv10)*D;
  A[2][16]=(3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[2][17]=(3.7499999999999999e-02*Jinv11+3.7499999999999999e-02*Jinv10)*D;
  A[2][18]=(4.1666666666666666e-03*Jinv01)*D;
  A[2][19]=(4.1666666666666666e-03*Jinv11)*D;
  A[2][20]=(0.0)*D;
  A[2][21]=(0.0)*D;
  A[2][22]=(-3.7499999999999999e-02*Jinv01)*D;
  A[2][23]=(-3.7499999999999999e-02*Jinv11)*D;
  A[2][24]=(0.0)*D;
  A[2][25]=(0.0)*D;
  A[2][26]=(-3.7499999999999999e-02*Jinv01-7.4999999999999997e-02*Jinv00)*D;
  A[2][27]=(-3.7499999999999999e-02*Jinv11-7.4999999999999997e-02*Jinv10)*D;
  A[2][28]=(3.7499999999999999e-02*Jinv01+7.4999999999999997e-02*Jinv00)*D;
  A[2][29]=(3.7499999999999999e-02*Jinv11+7.4999999999999997e-02*Jinv10)*D;
  A[2][30]=(3.7499999999999999e-02*Jinv01)*D;
  A[2][31]=(3.7499999999999999e-02*Jinv11)*D;
  A[2][32]=(0.0)*D;
  A[2][33]=(0.0)*D;
  A[2][34]=(0.0)*D;
  A[2][35]=(0.0)*D;
  A[2][36]=(0.0)*D;
  A[2][37]=(0.0)*D;
  A[2][38]=(0.0)*D;
  A[2][39]=(0.0)*D;
  A[3][0]=(-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[3][1]=(-4.1666666666666666e-03*Jinv11-4.1666666666666666e-03*Jinv10)*D;
  A[3][2]=(0.0)*D;
  A[3][3]=(0.0)*D;
  A[3][4]=(0.0)*D;
  A[3][5]=(0.0)*D;
  A[3][6]=(4.1666666666666666e-03*Jinv00)*D;
  A[3][7]=(4.1666666666666666e-03*Jinv10)*D;
  A[3][8]=(0.0)*D;
  A[3][9]=(0.0)*D;
  A[3][10]=(0.0)*D;
  A[3][11]=(0.0)*D;
  A[3][12]=(0.0)*D;
  A[3][13]=(0.0)*D;
  A[3][14]=(0.0)*D;
  A[3][15]=(0.0)*D;
  A[3][16]=(0.0)*D;
  A[3][17]=(0.0)*D;
  A[3][18]=(4.1666666666666666e-03*Jinv01)*D;
  A[3][19]=(4.1666666666666666e-03*Jinv11)*D;
  A[3][20]=(0.0)*D;
  A[3][21]=(0.0)*D;
  A[3][22]=(-7.4999999999999997e-02*Jinv01)*D;
  A[3][23]=(-7.4999999999999997e-02*Jinv11)*D;
  A[3][24]=(0.0)*D;
  A[3][25]=(0.0)*D;
  A[3][26]=(-7.4999999999999997e-02*Jinv00)*D;
  A[3][27]=(-7.4999999999999997e-02*Jinv10)*D;
  A[3][28]=(7.4999999999999997e-02*Jinv01+7.4999999999999997e-02*Jinv00)*D;
  A[3][29]=(7.4999999999999997e-02*Jinv11+7.4999999999999997e-02*Jinv10)*D;
  A[3][30]=(0.0)*D;
  A[3][31]=(0.0)*D;
  A[3][32]=(-3.7499999999999999e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[3][33]=(-3.7499999999999999e-02*Jinv11-3.7499999999999999e-02*Jinv10)*D;
  A[3][34]=(3.7499999999999999e-02*Jinv00)*D;
  A[3][35]=(3.7499999999999999e-02*Jinv10)*D;
  A[3][36]=(3.7499999999999999e-02*Jinv01)*D;
  A[3][37]=(3.7499999999999999e-02*Jinv11)*D;
  A[3][38]=(0.0)*D;
  A[3][39]=(0.0)*D;
  int vnbf = 40;  int pnbf = 4;  

  pair<int,int> index; 
  for (int i=0; i< pnbf; i++) {
    index.first = ipdof[i]; 
    for (int j=0; j< vnbf; j++) {
      index.second = ivdof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
