#include <SyFi.h>

using namespace GiNaC; 



int main() {
  int order = 2; 
  int nsd   = 2; 

  ex polynom_space = pol(order,nsd, "a"); 
  cout <<"polynom_space "<<polynom_space<<endl; 

  ex p = polynom_space.op(0); 
  cout <<"polynom p = "<<p<<endl; 
  EQUAL_OR_DIE(p,"y^2*a5+x^2*a3+a2*y+y*x*a4+a0+a1*x"); 

  ex dpdx = diff(p,x);   
  cout <<"dpdx = "<<dpdx<<endl; 
  EQUAL_OR_DIE(dpdx, "y*a4+a1+2*x*a3"); 

  Triangle triangle(lst(0,0), lst(1,0), lst(0,1)); 
  ex intp = triangle.integrate(p); 
  cout <<"integral of p over reference triangle = "<<intp<<endl;  
  EQUAL_OR_DIE(intp, "1/6*a2+1/6*a1+1/12*a5+1/2*a0+1/24*a4+1/12*a3"); 

  //Bernstein polynomial in barycentric coordinates 

  ex polynom_space2 = bernstein(order,triangle, "a"); 
  ex p2 = polynom_space2.op(0); 
  cout <<"polynom p2 = "<<p2<<endl; 
  EQUAL_OR_DIE(p2, "y^2*a0+2*(1-y-x)*x*a4+2*(1-y-x)*a3*y+(1-y-x)^2*a5+2*a1*y*x+a2*x^2"); 

  ex dp2dx = diff(p2,x);   
  cout <<"dp2dx = "<<dp2dx<<endl; 
  EQUAL_OR_DIE(dp2dx, "2*a1*y+2*(-1+y+x)*a5+2*a2*x+2*(1-y-x)*a4-2*a3*y-2*x*a4"); 

  ex intp2 = triangle.integrate(p2); 
  cout <<"integral of p2 over reference triangle = "<<intp<<endl;  
  EQUAL_OR_DIE(intp2, "1/12*a3+1/12*a2+1/12*a1+1/12*a5+1/12*a0+1/12*a4"); 

 
 
 

}
